﻿// -----------------------------------------------------------------------------------
//
//	playback.js v1.0
//	by Shinichi Fujikawa (f-shin [at] milkstand.net) - http://www.milkstand.net
//	3/31/06
//
//	For more information on this script, visit:
//	http://f-shin.net/labs/2006/10/playbackjs.html
//
//	Licensed under the Creative Commons Attribution 2.5 License - http://creativecommons.org/licenses/by/2.5/
//	
//  spacial thanks to WebSig24/7 ( http://websig247.jp )
//
// -----------------------------------------------------------------------------------
/*
    NAME 
	  playback.js - easy slide presentation 
	  
    Library
      require lightbox.js
	  
	Sysnopsis
　　  Call at onload event.
	  myPlayback = new CPlayback( options );

*/


//CSlide ::  slide data class
CSlide = Class.create();
CSlide.prototype = {
	title : String ,
	time : String ,
	imageUrl : String , 
	thumbUrl : String , 
	
	initialize : function (){

		var title = arguments[0].title;
		var time = arguments[0].time;
		var imageUrl = arguments[0].imageUrl;
		var thumbUrl = arguments[0].thumbUrl;
		
		this.title = (title ? title : "");
		this.time = (time ? time : 0);
		this.imageUrl = (imageUrl ? imageUrl : "");
		this.thumbUrl = (thumbUrl ? thumbUrl : "");
	
	}

};

// CPlayback :: slide control class

CPlayback = Class.create();
CPlayback.prototype = {
	slideList:Array , 
	startIdx:Number , 
	lightBox:Object , 
	player : Object , 
	parmalink: String , 
	
	initialize : function (){
	
		this.slideList = new Array();
		//init values
	    var options = Object.extend({
			  parmalink: "",    // 未使用
			  contentPath: "flv/movie.flv" ,  // 音声、動画データをswf/player.swfを起点に相対パスで設定(注意！)
			  slidePath: "img/" ,  // スライドが格納されているパス。 <slidepath> / <slidePrefix> + 01(連番) + ". jpg"
			  thumbPath: "thumb/" , // サムネイルが格納されているパス。
			  thumbWidth : 120,  //サムネイルの横幅(px)
			  thumbHeight: 90,   //サムネイルの縦幅(px)
    		  startSlide:  0,    //開始するスライドの枚数(0が1枚目）
			  slidePrefix: "slide_",  //スライドファイルの先頭
			  slideTime: [0] ,        //スライド切り替え時間を配列で指定（必須）
			  slideTitle: [""] ,      //スライドタイトルを配列で指定
			  imgId : "imgArea" ,     //本クラスから出力するサムネイル一覧のID
			  playerId : "playerArea"  // 音声、動画プレーヤーのサムネイルID
		    }, arguments[0] || {});

	    this.start(options);
	
	},

	//サムネイル一覧のHTMLテンプレート
	getSlideTmpl : function(){
	
		var imgTmpl = "<div class='thumb-div' id='thumb##num##'><a href='##fn##' id='link_##num##' title='##title##' rel='lightbox[group]'><img class='thumb-img' id='thumb-img##num##' src='##thumb##' width='##width##' height='##height##'></a>";
imgTmpl += "<br /><a href='javascript:void(0)' onclick='myPlayback.playSlide(##num##)'>##num-view##(##time##)</a></div>";

		return imgTmpl;
	
	},
	
	//swf/player.swfのHTMLテンプレート
	getPlayerTmpl : function(){

		var plTmpl = '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0" width="390" height="40" id="player" align="middle">'
		+ '<param name="allowScriptAccess" value="sameDomain" />'
		+ '<param name="wmode" value="Transparent" />'
		+ '<param name="base" value="swf" />'
		+ '<param name="FlashVars" value="contentPath=##content_path##" />'
		+ '<param name="movie" value="swf/player.swf" /><param name="quality" value="high" /><param name="bgcolor" value="#ffffff" /><embed src="swf/player.swf" quality="high" bgcolor="#ffffff" width="390" height="40" name="player" align="middle" allowScriptAccess="always" wmode="Transparent" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" FlashVars="contentPath=##content_path##" base="swf" \/>'
		+ '<\/object>';
		
		return plTmpl

	},

	//コンストラクタから呼び出される。再生開始までの処理を行う
	start : function (o){
	
		this.startIdx = o.startSlide;
		this.parmalink = o.parmalink;

		 var imgTileSrc = "";

		 for (var i = 0  ; i < o.slideTime.length  ; i++){

			var slNum = "";
			if ( i < 9 ) slNum = "0" + (i + 1);
		   	     else slNum = (i + 1);
				 
			var tmpSlide = new CSlide(
				{
				title:
					((o.slideTitle  && o.slideTitle.length && o.slideTitle.length > i ) ? o.slideTitle[i] : "") ,
				time : o.slideTime[i] , 
				imageUrl :  o.slidePath + o.slidePrefix + slNum + ".jpg"  ,
				thumbUrl :  o.thumbPath + o.slidePrefix + slNum + ".jpg"
				}
			);
	
			if (this.startIdx <= i){
				var tmp =  this.getSlideTmpl();
				tmp = tmp.replace(/##fn##/g , tmpSlide.imageUrl);
				tmp = tmp.replace(/##thumb##/g , tmpSlide.thumbUrl);
				tmp = tmp.replace(/##time##/g , this.timeFormat(tmpSlide.time));
				tmp = tmp.replace(/##title##/g , tmpSlide.title);
				tmp = tmp.replace(/##width##/g , o.thumbWidth);
				tmp = tmp.replace(/##height##/g , o.thumbHeight);
				tmp = tmp.replace(/##num-view##/g , i - this.startIdx + 1);
				imgTileSrc += tmp.replace(/##num##/g , i);
				this.slideList[i] = tmpSlide; 
			}
		 }
		 $(o.imgId).innerHTML = imgTileSrc;

		//require lightbox.js
		initLightbox();
		this.lightBox = myLightbox;
		
		var plSrc = this.getPlayerTmpl().replace(/##content_path##/g , o.contentPath);	
		$(o.playerId).innerHTML = plSrc;

		function thisMovie(movieName) {
		    if (navigator.appName.indexOf("Microsoft") != -1) {
		        return window[movieName]
		    }
		    else {
		        return document[movieName]
		    }
		}
		this.player= thisMovie("player");
	
		/*
		var lh = unescape(location.hash);
		var initIdx ;
		if (lh.length >= 2){
		   	var tmp = lh.substring(1,lh.length)
			if (tmp.match(/[0-9]+/)){
  		   		initIdx = parseInt(tmp);
			}else{
				initIdx =this.startIdx;
			}
		}else{
		   initIdx =this.startIdx;
		}

		setTimeout(function(){ this.playSlide(initIdx) }.bind(this) , 3000);
		*/
	
	},
	
	//引数nから動画、音声を再生するメソッド(0が1枚目のスライド）
	playSlide : function(n){

		if (this.slideList.length > n){
			this.player.playFlv(this.slideList[n].time);
		}else{
			this.player.playFlv(0);
		}
	},

	//引数 time（秒）に対応するスライド番号を戻す
	getSlideNum : function(time){


		for (var i = this.startIdx ; i < this.slideList.length - 1 ; i++){

			if (this.slideList[i].time <= time && this.slideList[i + 1].time > time){
				return i;
				
			}
	
		}
		if (this.slideList[i].time < time) return i;

		return 0;
	},
	
	//引数 nの次のスライドから再生する
	nextSlide : function(n){
		if ( n && n < this.slideList.length)	
			this.playSlide(n + 1);
	},
	//引数 nの前のスライドから再生する
	prevSlide : function(n){
		if (n &&  n > this.startIdx)
			this.playSlide(n -1);
	} ,

	//引数 sec （秒）を0:00:00の文字フォーマットで返す
	timeFormat:function (sec){

			var h = parseInt( sec / 3600 );
			var m = parseInt((sec - h * 3600) / 60);
			var s = parseInt(sec - h * 3600 - m * 60); 
			
			if (m < 10) m = "0" + m;
			if (s < 10) s = "0" + s;
		
			return h + ":" + m + ":" + s;
	}
	
}

// global変数、イベント処理

// call from Flash Player
// 再生時間の更新などの画面制御系の処理はすべてここだけに書いてあります。

var nowSlide = undefined;   //現在のスライド番号（0-）

//Flashのプレーヤーであるswf/player.swfから呼び出されます
function OnPlayHeadChange(state , playtime){

var tmpNum = myPlayback.getSlideNum(playtime);

if (nowSlide != tmpNum){
	nowSlide = tmpNum;

	myLightbox.start($('link_' + nowSlide));
	$('nowSlideView').src = myPlayback.slideList[nowSlide].thumbUrl;
	
	for (var i=myPlayback.startIdx ; i < myPlayback.slideList.length ; i++){
	
		var t = $('thumb-img' + i);
		
		if (nowSlide == i){
			t.style.border="2px solid #F66";
		}else{
			t.style.border="none";
		}
	}
	
	/*
	location.hash=nowSlide;
	var hbAdd = "http://b.hatena.ne.jp/add?mode=confirm&url=##URL##";
	var hbEntry = "http://b.hatena.ne.jp/entry/##URL##";
	var hbImg = "http://b.hatena.ne.jp/entry/image/##URL##";

	$('hbAddLink').href= hbAdd.replace(/##URL##/g , myPlayback.parmalink + "#" + nowSlide);
	$('hbEntryLink').href= hbEntry.replace(/##URL##/g , myPlayback.parmalink + "#" + nowSlide);
	$('hbImg').src = hbImg.replace(/##URL##/g , myPlayback.parmalink + "#" + nowSlide);
	*/
}

	$('time').innerHTML= state + " / " + myPlayback.timeFormat(playtime) + " / 現在のスライド：" + (tmpNum - myPlayback.startIdx + 1);

}

//カーソルキーによる処理はここに記述
	function handleKey(ev){

		ev = (ev) ? ev : ((window.event) ? event : null );
		if (ev){
		
				switch (ev.keyCode) {
				case 37: //left
				case 80: //P
				case 66: //B
					myPlayback.prevSlide(nowSlide);
					break;
				case 38: //up

					break;
				case 39: //right
				case 70: //F
				case 78: //N
					myPlayback.nextSlide(nowSlide);
					break;
				case 40: // down

					break;
				}
			
			switch (ev.keyCode) {
				case 32: //space
					myLightbox.start($('link_' + nowSlide));
					break;
			}					
		}	
	}
	document.onkeyup = handleKey;
